/* ========
 * libqpace
 * ========
 * $Id: qpace.h 3053 2010-01-24 14:15:43Z pleiter $
 * -------------------------------------------------------------------------- */

#ifndef QPACE_H
#define QPACE_H

#define _GNU_SOURCE 1

#include <unistd.h>
#include <inttypes.h>
#include <pthread.h>
#include <stdarg.h>

#ifndef PPU_ONLY
#include <libspe2.h>
#endif

#include "qpace_mem.h"
#include "qpace_dcr.h"

void qpace_devmem_open();
void qpace_devmem_close();

void *qpace_mmap(int, off64_t, size_t);

void *qpace_mmap_iwc();
void *qpace_mmap_dcr();
void *qpace_mmap_dcrtnw();

int qpace_torus_init(unsigned char **, unsigned char **);
void qpace_torus_finish();

#ifndef PPU_ONLY
int qpace_get_spu_phys_id(spe_context_ptr_t);
#endif

typedef enum { qpace_log_err, qpace_log_info, qpace_log_debug } qpace_log_t;

void _qpace_log(qpace_log_t, int, const char*, const char*, ...);
void qpace_set_loglevel(qpace_log_t);

#define qpace_die(ARGS...)   _qpace_log(qpace_log_err,   1, __func__, ##ARGS)
#define qpace_err(ARGS...)   _qpace_log(qpace_log_err,   0, __func__, ##ARGS)
#define qpace_info(ARGS...)  _qpace_log(qpace_log_info,  0, __func__, ##ARGS)
#define qpace_debug(ARGS...) _qpace_log(qpace_log_debug, 0, __func__, ##ARGS)

#endif
